#!/usr/bin/env python

from re import compile, escape
from xml.sax.saxutils import escape as xmlEscape
from httplib import HTTPConnection
from urllib import urlopen
from lxml.etree import parse, tostring
import sys
import os

# this function is copied from the meresco software
def send(port, recordUpdate):
### FIXME port instelbaar maken ###
	connection = HTTPConnection('localhost', port)
#	connection = HTTPConnection('localhost', '7074')
#	connection = HTTPConnection('localhost', '5000')
	connection.putrequest("POST", "/update")
	connection.putheader("Host", "localhost")
	connection.putheader("Content-Type", "text/xml; charset=\"utf-8\"")
	connection.putheader("Content-Length", str(len(recordUpdate)))
	connection.endheaders()
	connection.send(recordUpdate)
	result = connection.getresponse()
	print result.read()

# from python-storage
HEX_TO_CHAR = lambda x:chr(int(x.group(1),16))
REVERSE_BAD_CHARS = compile('%([0-9A-F]{2})')
def unescapeName(name):
	return REVERSE_BAD_CHARS.sub(HEX_TO_CHAR, name)
BAD_CHARS = map(chr, range(32)) + ['/', '%', ',']
FIND_BAD_CHARS = compile('(^\.|' + '|'.join(map(escape, BAD_CHARS)) + ')')
CHAR_TO_HEX = lambda x: '%%%02X' % ord(x.group(1))
def escapeName(name):
    return FIND_BAD_CHARS.sub(CHAR_TO_HEX, str(name))

def makeRequest(id):
    part1, part2 = id.split(":", 1)
    # unescape niet echt nodig, alleen als identifier encoded is.
    #part2 = unescapeName(part2)
    print(part1 + ":" + part2)
    #print("part1=" + part1)
    #print("part2=" + part2)
    re = """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="http://www.loc.gov/zing/srw/" xmlns:ucp="http://www.loc.gov/ucp">
 <srw:version>1.0</srw:version>
 <ucp:action>info:srw/action/1/delete</ucp:action>
 <ucp:recordIdentifier>%(part1)s:%(part2)s</ucp:recordIdentifier>
</srw:updateRequest>"""
    # the request is finished by replaceing the variables by its values
    recordUpdate = re %locals()
    return recordUpdate

if len(sys.argv) != 3:
        print """Usage: sruupdate-delete.py <port updateserver> <file with identifiers of to be deleted records>
""";
        sys.exit()

port = sys.argv[1]
file = sys.argv[2]

for recordIdentifier in open(file, 'r').readlines():
    if recordIdentifier[0] == '#': continue
    recordUpdate = makeRequest(recordIdentifier.rstrip('\n'))
    # now we can send the request, wait (no need, immediate response) and see
    send(port, recordUpdate)
